(
	function()
	{
		"use strict"

		var oPhotoCapture

		oPhotoCapture =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			bInitialized:	false,
			bIsRunning:	false,
			bPermission:	false,
			sUrl:	"/tmp/VideoSnapshotUpload/upload.php",
            sUrlParams: "",

			oCanvasContext:	null,
			oStream:	null,

			oElements:
			{
				canvas:	null,
				submit:	null,
				target:	null,
				video:	null,
			},
			oDimensions:
			{
				width:    "320",
				height:	"240",

			},
            oMaxImageSize:"1280",
            oDevices: [],
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			get canvasContext()
			{
				return this.oCanvasContext
			},
			set canvasContext(oCanvasContext)
			{
				this.oCanvasContext = oCanvasContext
			},
			get dimensions()
			{
				return this.oDimensions
			},
			set xdimension(width)
			{
				this.oDimensions.width = width
			},
			set ydimension(height)
			{
				this.oDimensions.height = height
			},
			get elements()
			{
				return this.oElements
			},
			get hasPermission()
			{
				return this.bPermission
			},
			set hasPermission(bPermission)
			{
				this.bPermission = bPermission
			},
			get isInitialized()
			{
				return this.bInitialized
			},
			set isInitialized(bInitialized)
			{
				this.bInitialized = bInitialized
			},
			get isRunning()
			{
				return this.bIsRunning
			},
			set isRunning(bIsRunning)
			{
				this.bIsRunning = bIsRunning
			},
			get stream()
			{
				return this.oStream
			},
			set stream(oStream)
			{
				this.oStream = oStream
			},
			get target()
			{
				return this.elements.target
			},
			set target(eElement)
			{
				this.elements.target = eElement
			},
			get url()
			{
				return this.sUrl
			},
			set url(sUrl)
			{
				this.sUrl = sUrl
			},
			get urlparams()
			{
				return this.sUrl
			},
			set urlparams(sUrlParams)
			{
				this.sUrlParams = sUrlParams
			},
            get devices()
            {
                return this.oDevices;
            },
			get maxImageSize()
			{
				return this.oMaxImageSize
			},
			set maxImageSize(oMaxImageSize)
			{
				this.oMaxImageSize = oMaxImageSize
			},
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onPermissionReceived()
			{
				this.hasPermission = true
			},
			onStreamReceived(oStream)
			{
				this.elements.video.srcObject = oStream
				this.elements.video.play()
			},
			onSubmit()
			{
				this.capture().upload()
			},
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="structors">
			initialize(oDimensions)
			{
				if(oDimensions)
				{
					this.oDimensions = oDimensions
				}

                let camera_devices=[];
                try {
                    navigator.mediaDevices.enumerateDevices()
                        .then(devices =>
                        {
                            devices.forEach(device =>
                            {
                                if (device.kind === 'videoinput') {
                                    camera_devices.push(device);
                                }
                            });
                            this.oDevices = camera_devices
                            if(this.isInitialized) this.renderDevices();
                        });
                } catch (e) {
                    console.log(e);
                }

				this.onSubmit	= this.onSubmit	.bind(this)

				this.elements.canvas	= document.createElement("canvas")
				this.elements.canvas.width	= this.dimensions.width
				this.elements.canvas.height	= this.dimensions.height
				this.canvasContext	= this.elements.canvas.getContext("2d")
				this.elements.submit	= document.createElement("button")
				this.elements.submit.textContent = "Capture"
				this.elements.video	= document.createElement("video")
				this.elements.video.width	= this.dimensions.width
				this.elements.video.height	= this.dimensions.height
                this.elements.video.style.maxWidth="100%";
                this.elements.video.style.height="auto";

				this.elements.submit	.setAttribute("type", "button")

				this.elements.submit	.addEventListener("click"	, this.onSubmit	)

				this.isInitialized = true

				return this
			},
			finalize()
			{
				this.elements.canvas.remove()
				this.elements.canvas	= null
				this.elements.video.remove()
				this.elements.video	= null

				return this
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_isBlank()
			{
				var oBlankCanvas

				oBlankCanvas	= document.createElement("canvas")
				oBlankCanvas.width	= this.elements.canvas.width
				oBlankCanvas.height	= this.elements.canvas.height

				return this.elements.canvas.toDataURL() == oBlankCanvas.toDataURL()
			},
			_xhr: function(oData)
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var	oXhr

						oXhr = new XMLHttpRequest()

						oXhr.addEventListener
						(
							"load",
							() =>
							{
								if(oXhr.status >= 200 && oXhr.status < 300)
								{
									fResolve(oXhr.response)
								}
								else
								{
									fReject({status: oXhr.status, statusText: oXhr.statusText})
								}
							}
						)
						oXhr.addEventListener
						(
							"error",
							() =>
							{
								fReject({status: oXhr.status, statusText: oXhr.statusText})
							}
						)

						oXhr.open(oData.method, oData.url)
						oXhr.send(oData.data)
					}
				)
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			capture()
			{
				if(!this.hasPermission)
				{
					throw new Error("Missing video capture permission!")
				}

				this.canvasContext.drawImage(this.elements.video, 0, 0, this.dimensions.width, this.dimensions.height)
				this.stop().hide({submit: true, video: true,}).show({canvas: true})

				return this
			},
            blobToBase64(blob) {
                const reader = new FileReader();
                reader.readAsDataURL(blob);
                return new Promise(resolve => {
                    reader.onloadend = () => {
                        resolve(reader.result);
                    };
                });
            },
            async liveCapture()
            {
                if(!this.hasPermission)
				{
					throw new Error("Missing video capture permission!");
				}
                this.canvasContext.drawImage(this.elements.video, 0, 0, this.dimensions.width, this.dimensions.height);

				if(this._isBlank())
				{
					throw new Error("No photo has been taken!")
				}
                let blob = await new Promise(resolve =>
                {
                    this.elements.canvas.toBlob(oBlob => resolve(oBlob));
                });
                return await this.blobToBase64(blob);
            },
			clear()
			{
				this.canvasContext.clearRect(0, 0, this.elements.canvas.width, this.elements.canvas.height)
			},
			hide(oOptions)
			{
				if(oOptions)
				{
					if(oOptions.video)
					{
						this.elements.video.remove()
					}
					if(oOptions.canvas)
					{
						this.elements.canvas.remove()
					}
					if(oOptions.submit)
					{
						this.elements.submit.remove()
					}
				}

				return this
			},
			show(oOptions, eElement)
			{
				eElement	= eElement || this.elements.target
				oOptions	= oOptions || {submit: true, video: true, devices: true}

				if(oOptions)
				{
					Array.prototype.slice.call(eElement.children).forEach((eElement) => {eElement.remove()})

					if(oOptions.video)
					{
						eElement.appendChild(this.elements.video)
						this.elements.video.play()
					}
					if(oOptions.canvas)
					{
						eElement.appendChild(this.elements.canvas)
					}
					if(oOptions.submit)
					{
						eElement.appendChild(this.elements.submit)
					}
                    if(oOptions.devices)
                    {
                        this.renderDevices();
                    }
				}

				return this
			},
            renderDevices()
            {
                if(this.devices.length>1)
                {
                    let select = document.createElement('select')
                    select.classList.add("input");
                    select.id="cameraSelector";
                    for(let camera of this.devices)
                    {
                        let option = document.createElement('option');
                        option.value=camera.deviceId;
                        option.innerText=camera.label?camera.label:"(unnamed camera)";
                        select.appendChild(option);
                    }
                    if(document.querySelector('#cameraSelector')) document.querySelector('#cameraSelector').remove();
                    document.querySelector("#photoCaptureContainer").insertAdjacentHTML('beforebegin',select.outerHTML);

                    if(this.stream && this.stream.active)
                    {
                        let tracks = this.stream.getVideoTracks();
                        tracks.forEach(track =>
                        {
                            for(let camera of this.devices)
                            {
                                if(track.label===camera.label) document.querySelector('#cameraSelector').value=camera.deviceId;
                            }
                        });
                    }

                    document.querySelector('#cameraSelector').addEventListener('change',(ev)=>
                    {
                        let value = ev.currentTarget.value;
                        this.switchDevice(value);
                    });
                }
            },
			start(options, onReady)
			{
                if(typeof options === "undefined") options = {'facingMode': 'environment'};
                options.width={ideal:this.maxImageSize};
                options.heigt={ideal:this.maxImageSize};
				navigator.mediaDevices.getUserMedia({video: options})
				.then
				(
					(oStream) =>
					{
						this.onPermissionReceived()
						this.onStreamReceived(oStream)
						this.stream = oStream

                        this.resizeCanvas();

                        this.renderDevices();
                        if(typeof onReady !== "undefined") onReady();
					}
				)
				this.clear()

				this.isRunning = true

				return this
			},
			stop()
			{
				this.stream.getTracks().forEach((oTrack) => {oTrack.stop()})

				this.stream	= null
				this.isRunning	= false

				return this
			},
            switchDevice(id)
            {
                this.stop();
                this.start({deviceId:{exact:id}});
            },
            resizeCanvas(maxSize)
            {
                if(typeof maxSize==="undefined") maxSize=this.maxImageSize;
                let track = this.oStream.getVideoTracks()[0];
                if(track)
                {
                    let meta = track.getSettings();
                    let dim = {
                        x:meta.width,
                        y:meta.height
                    };
                    let newDim={
                        x:dim.x,
                        y:dim.y
                    };
                    if(dim.x>maxSize || dim.y>maxSize)
                    {
                        // longest edge is greater than maxSize (must resize)
                        if(dim.x>dim.y) // landscape
                        {
                            newDim.x = maxSize;
                            newDim.y = (dim.y*maxSize)/dim.x;
                        }
                        else // portrait
                        {
                            newDim.x = (dim.x*maxSize)/dim.y;
                            newDim.y = maxSize;
                        }
                    }
                    this.oDimensions={
                        width:newDim.x,
                        height:newDim.y
                    };
                    this.elements.video.width	= this.dimensions.width;
                    this.elements.video.height	= this.dimensions.height;
                    this.elements.canvas.width	= this.dimensions.width;
                    this.elements.canvas.height	= this.dimensions.height;

                }
            },
			upload(callback,addData)
			{
                if(typeof callback==="undefined") callback = () => {};
                if(typeof addData==="undefined") addData = {};
				if(!this.hasPermission)
				{
					throw new Error("Missing video capture permission!")
				}
				if(this._isBlank())
				{
					throw new Error("No photo has been taken!")
				}

				this.elements.canvas.toBlob
				(
					async (oBlob) =>
					{
                        addData.image = await this.blobToBase64(oBlob);
                        API.POST(this.url,addData,false,false,false).then(callback);
                        /*
						var	oFormData = new FormData()

						oFormData.append("image", oBlob)
						this._xhr
						({
							data:	oFormData,
							method:	"POST",
							url:	this.url,
						})*/
					}
				)

				return this
			},
			// </editor-fold>
			// </editor-fold>
		}

		/*
		######## ##     ## ########   #######   ######  ##     ## ########  ########
		##        ##   ##  ##     ## ##     ## ##    ## ##     ## ##     ## ##
		##         ## ##   ##     ## ##     ## ##       ##     ## ##     ## ##
		######      ###    ########  ##     ##  ######  ##     ## ########  ######
		##         ## ##   ##        ##     ##       ## ##     ## ##   ##   ##
		##        ##   ##  ##        ##     ## ##    ## ##     ## ##    ##  ##
		######## ##     ## ##         #######   ######   #######  ##     ## ########
		*/
		// <editor-fold desc="exposure">
		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.photoCapture = oPhotoCapture
		// </editor-fold>
	}
)()
