// QRCODE reader Copyright 2011 Lazar Laszlo
// http://www.webqr.com
var gCtx = null;
var gCanvas = null;
var c = 0;
var stype = 0;
var gUM = false;
var webkit = false;
var moz = false;
var v = null;
var startTime = null;
window.qr_read_callback = (r) => console.log(r);
var imghtml = '<div id="qrfile"><canvas id="out-canvas" width="320" height="240"></canvas>' +
    '<div id="imghelp">drag and drop a QRCode here' +
    '<br>or select a file' +
    '<input type="file" onchange="handleFiles(this.files)"/>' +
    '</div>' +
    '</div>';
var vidhtml = '<video id="v" autoplay style="max-width:100%;"></video>';

qr_camera_devices=[];
qr_camera_active_device_id=null;

function dragenter(e) {
    e.stopPropagation();
    e.preventDefault();
}
function dragover(e) {
    e.stopPropagation();
    e.preventDefault();
}
function drop(e) {
    e.stopPropagation();
    e.preventDefault();
    var dt = e.dataTransfer;
    var files = dt.files;
    if (files.length > 0) {
        handleFiles(files);
    } else
    if (dt.getData('URL')) {
        qrcode.decode(dt.getData('URL'));
    }
}
function handleFiles(f) {
    var o = [];
    for (var i = 0; i < f.length; i++) {
        var reader = new FileReader();
        reader.onload = (function(theFile) {
            return function(e) {
                gCtx.clearRect(0, 0, gCanvas.width, gCanvas.height);
                qrcode.decode(e.target.result);
            };
        })(f[i]);
        reader.readAsDataURL(f[i]);
    }
}
function initCanvas(w, h) {
    gCanvas = document.getElementById("qr-canvas");
    gCanvas.style.width = w + "px";
    gCanvas.style.height = h + "px";
    gCanvas.width = w;
    gCanvas.height = h;
    gCtx = gCanvas.getContext("2d");
    gCtx.clearRect(0, 0, w, h);
}
function captureToCanvas() {
    if (stype != 1)
        return;
    if (gUM) {
        try {
            if(new Date().getTime()-startTime>5000)
            {
                gCtx.drawImage(v, 0, 0);
                try {
                    qrcode.decode();
                } catch (e) {
                    if(typeof(e) === "object")
                    {
                        qr_reset();
                        return;
                    }
                    console.log(e);
                };
            }
        } catch (e) {
            console.log(e);
        };
        setTimeout(captureToCanvas, 200);
    }
}
function htmlEntities(str) {
    return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
}
function read(a) {
    let continueReading = qr_read_callback(a);
    if(continueReading!==false)
    {
        qr_initialize();
    }

}
function isCanvasSupported() {
    var elem = document.createElement('canvas');
    return !!(elem.getContext && elem.getContext('2d'));
}
function success(stream) {
    console.log(stream);
    v.srcObject = stream;
    v.play();
    gUM = true;
    startTime=new Date().getTime();
    setTimeout(captureToCanvas, 200);
}
function error(error) {
    console.log(error);
    gUM = false;
    return;
}
function qr_initialize() {
    if (isCanvasSupported() && window.File && window.FileReader) {
        initCanvas(800, 600);
        qrcode.callback = read;
        document.getElementById("mainbody").style.display = "inline";
        setwebcam();
    } else {
        document.getElementById("mainbody").style.display = "inline";
        document.getElementById("mainbody").innerHTML = '<p id="mp1">QR code scanner for HTML5 capable browsers</p><br>' +
            '<br><p id="mp2">sorry your browser is not supported</p><br><br>' +
            '<p id="mp1">try <a href="http://www.mozilla.com/firefox"><img src="firefox.png"/></a> or <a href="http://chrome.google.com"><img src="chrome_logo.gif"/></a> or <a href="http://www.opera.com"><img src="Opera-logo.png"/></a></p>';
    }
}
function setwebcam(deviceID) {
    if(typeof deviceID!=="undefined")
    {
        setwebcam2({
            'deviceId': {
                'exact': deviceID
            },
            'facingMode': 'environment'
        });
        return;
    }
    var options = true;
    if (navigator.mediaDevices && navigator.mediaDevices.enumerateDevices) {
        qr_camera_devices=[];
        try {
            navigator.mediaDevices.enumerateDevices()
                .then(function(devices) {
                    devices.forEach(function(device) {
                        console.log("Device found: ",device);
                        if (device.kind === 'videoinput') {
                            qr_camera_devices.push(device);
                            if (device.label.toLowerCase().search("back") > -1)
                                options = {
                                    'deviceId': {
                                        'exact': device.deviceId
                                    },
                                    'facingMode': 'environment'
                                };
                        }
                        console.log(device.kind + ": " + device.label + " id = " + device.deviceId);
                    });
                    if(options===true && qr_camera_devices.length>0) { setwebcam(qr_camera_devices[0].deviceId); }
                    else setwebcam2(options);
                });
        } catch (e) {
            console.log(e);
        }
    } else {
        console.log("no navigator.mediaDevices.enumerateDevices");
        setwebcam2(options);
    }
}
function setwebcam2(options) {
    console.log(options);
    if(options==="") options=true;
    if(options!==true)
    {
        if(options.deviceId.exact==="") options=true;
        else qr_camera_active_device_id=options.deviceId.exact;
    }
    //if (stype == 1) {
    //    setTimeout(captureToCanvas, 500);
    //    return;
    //}
    var n = navigator;
    if(v && v.srcObject)
    {
        v.srcObject.getTracks().forEach(track => track.stop());
    }
    let cameraSelector = '';
    // console.log("Cams: ",qr_camera_devices);
    if(qr_camera_devices.length>1)
    {
        cameraSelector = '<br/><select class="input" style="width: 640px; max-width:100%;" id="cameraSelector">'+qr_camera_devices.map(device =>
        {
            let sel = device.deviceId===qr_camera_active_device_id?" selected":"";
            return '<option value="'+device.deviceId+'"'+sel+'>'+(device.label!=""?device.label:"unlabeled device")+' (id:'+(device.deviceId.substr(0,8))+')'+'</option>';
        }).join()+'</select>';
    }
    document.getElementById("outdiv").innerHTML = vidhtml+cameraSelector;
    v = document.getElementById("v");
    if(document.getElementById("cameraSelector")) document.getElementById("cameraSelector").addEventListener('change',(ev) =>
    {
        ev.preventDefault();
        let newcam = ev.currentTarget.value;
        setwebcam(newcam);
    });
    if (n.mediaDevices.getUserMedia) {
        n.mediaDevices.getUserMedia({
            video: options,
            audio: false
        }).
        then(function(stream) {
            success(stream);
        }).catch(function(e) {
            error(e)
        });
    } else
    if (n.getUserMedia) {
        webkit = true;
        n.getUserMedia({
            video: options,
            audio: false
        }, success, error);
    } else
    if (n.webkitGetUserMedia) {
        webkit = true;
        n.webkitGetUserMedia({
            video: options,
            audio: false
        }, success, error);
    }
    stype = 1;
    setTimeout(captureToCanvas, 200);
}
function qr_stop()
{
    if(v && v.srcObject)
    {
        v.srcObject.getTracks().forEach(track => track.stop());
    }
}
function qr_reset()
{
    qr_stop();
    gCtx = null;
    gCanvas = null;
    c = 0;
    stype = 0;
    gUM = false;
    webkit = false;
    moz = false;
    v = null;
    window.qr_read_callback = (r) => console.log(r);
}
