(
	function()
	{
		"use strict"

		var oQrCodeReader

		oQrCodeReader =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			oOverlay:	null,
			oQCodeDecoder:	null,

			oElements:
			{
				video:	null,
			},
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			get elements()
			{
				return this.oElements
			},
			get overlay()
			{
				return this.oOverlay
			},
			set overlay(oOverlay)
			{
				this.oOverlay = oOverlay
			},
			get qCodeDecoder()
			{
				return this.oQCodeDecoder
			},
			set qCodeDecoder(oQCodeDecoder)
			{
				this.oQCodeDecoder = oQCodeDecoder
			},
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onQrCodeResult(sResult)
			{
				console.log("QR-Code: " + sResult);
				//window.metasec.presenter.loadQR("login_via_qrcode",sResult)
                var di_id = this.getParameterByName('di_id');
                console.log("di_id: " + di_id);
                location.href = "/portals/qr_scan_event.php?qr_code=" + sResult + "&di_id=" + di_id;

				this.finalize()

			},
			onUnload()
			{
				this.finalize()
			},
			onVideoEnded()
			{
				this.stop()
			},
			onVideoStarted()
			{
				this.overlay.create()
			},
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="structors">
			initialize()
			{
				var oCrosshairSvgDownload

				oCrosshairSvgDownload = new this._xhr({method: "GET", url: "/metacore/jslibs/qrcodereader/crosshair.svg",})

				this.elements.video	= document.querySelector("#qrcodescanner-video"	)

				this.onUnload	= this.onUnload	.bind(this)
				this.onVideoEnded	= this.onVideoEnded	.bind(this)
				this.onVideoStarted	= this.onVideoStarted	.bind(this)

				this.elements.video	.addEventListener("playing"	, this.onVideoStarted	)
				this.elements.video	.addEventListener("ended"	, this.onVideoEnded	)
				window	.addEventListener("beforeunload"	, this.onUnload	)

				this.overlay	= new window.metasec.Overlay(this.elements.video, null, {content: {height: "100%",}, shadow: false,})
				this.qCodeDecoder = new QCodeDecoder()

				oCrosshairSvgDownload
				.then
				(
					(sCrosshairSvg) =>
					{
						this.overlay.content = `<div id="qrcodescanner-overlay">${sCrosshairSvg}</div>`
					}
				)
				this.start()

				return this
			},
			finalize()
			{
				this.overlay.destructor()
				this.overlay	= undefined

				this.qCodeDecoder.stop()
				this.qCodeDecoder	= undefined

				this.elements.video	.removeEventListener("playing"	, this.onVideoStarted	)
				this.elements.video	.removeEventListener("ended"	, this.onVideoEnded	)
				this.elements.video = undefined

				window	.removeEventListener("beforeunload"	, this.onUnload	)

				return this
			},
            
            getParameterByName(name, url) {
                if (!url) url = window.location.href;
                name = name.replace(/[\[\]]/g, "\\$&");
                var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                    results = regex.exec(url);
                if (!results) return null;
                if (!results[2]) return '';
                return decodeURIComponent(results[2].replace(/\+/g, " "));
            },
            
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_xhr: function(oData)
			{
				return new Promise
				(
					(fResolve, fReject) =>
					{
						var	oXhr

						oXhr = new XMLHttpRequest()
						oXhr.addEventListener
						(
							"load",
							() =>
							{
								if(oXhr.status >= 200 && oXhr.status < 300)
								{
									fResolve(oXhr.response)
								}
								else
								{
									fReject({status: oXhr.status, statusText: oXhr.statusText})
								}
							}
						)
						oXhr.addEventListener
						(
							"error",
							() =>
							{
								fReject({status: oXhr.status, statusText: oXhr.statusText})
							}
						)

						oXhr.open(oData.method, oData.url)
						oXhr.send(oData.data)
					}
				)
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			start()
			{
				this.qCodeDecoder.decodeFromCamera(this.elements.video, (oError, sResult) => {if(!oError){this.onQrCodeResult(sResult)}})

				return this
			},
			stop()
			{
				this.qCodeDecoder.stop()

				return this
			},
			// </editor-fold>
			// </editor-fold>
		}

		oQrCodeReader.initialize()
	}
)()
